﻿/*
 * 公司：
 * 说明：用户登录
 * 作者：党章
 * 创建：2010-07-21
 * 调用方法： Post
 * 传递数据：code=密文
 * 维护记录：
 * ===========================================================
 * 时间：2010-07-26
 * 人员：党章
 * 维护内容：
 * 1.增加访问者信息的记录
 * ===========================================================
 * ===========================================================
 * 时间：2010-08-02
 * 人员：党章
 * 维护内容：
 * 1.修改同步登录和同步登出的验证方式，去掉了cookie，改为session验证
 * ===========================================================
 */


using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;
using System.Configuration;
using System.Collections;
using System.IO;
using System.Web.Security;

namespace HappyFarm.Web.api
{
    public partial class uc : System.Web.UI.Page
    {
        private const string UC_VERSION = "1.0.0";
        private const string API_DELETEUSER = "1";
        private const string API_RENAMEUSER = "1";
        private const string API_GETTAG = "1";
        private const string API_SYNLOGIN = "1";
        private const string API_SYNLOGOUT = "1";
        private const string API_UPDATEPW = "1";
        private const string API_UPDATEBADWORDS = "1";
        private const string API_UPDATEHOSTS = "1";
        private const string API_UPDATEAPPS = "1";
        private const string API_UPDATECLIENT = "1";
        private const string API_UPDATECREDIT = "1";
        private const string API_GETCREDITSETTINGS = "1";
        private const string API_UPDATECREDITSETTINGS = "1";
        private const string API_RETURN_SUCCEED = "1";
        private const string API_RETURN_FAILED = "-1";
        private const string API_RETURN_FORBIDDEN = "-2";

        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                string code = Request.QueryString["code"];

                #region 获取用户的请求的信息
                string strRequestInfo = "";
                strRequestInfo =
                  "客户端计算机名：" + Request.UserHostName + "<BR />" +
                 "客户端IP：" + Request.UserHostAddress + "<BR />" +
                 "浏览器：" + Request.Browser.Browser + "<BR />" +
                 "浏览器版本：" + Request.Browser.Version + "<BR />" +
                 "浏览器类型：" + Request.Browser.Type + "<BR />" +
                 "客户端操作系统：" + Request.Browser.Platform + "<BR />" +
                 "是否支持Java：" + Request.Browser.JavaApplets + "<BR />" +
                 "是否支持框架网页：" + Request.Browser.Frames + "<BR />" +
                 "是否支持Cookie：" + Request.Browser.Cookies + "<BR />" +
                 "客户端.NET Framework版本：" + Request.Browser.ClrVersion + "<BR />" +
                 "JScript版本：" + Request.Browser.JScriptVersion + "<BR />" +



                 "请求的虚拟路径：" + Request.Path + "<BR />";

                for (int i = 0; i < Request.Headers.Count; i++)
                {
                    strRequestInfo += Request.Headers.Keys[i] + ":" + Request.Headers[Request.Headers.Keys[i]] + "<BR />";
                }
                strRequestInfo += "请求的物理路径：" + Request.PhysicalPath + "<BR />" +
                 "浏览器类型和版本：" + Request.ServerVariables["HTTP_USER_AGENT"] + "<BR />" +
                 "用户的IP地址：" + Request.ServerVariables["REMOTE_ADDR"] + "<BR />" +
                 "请求的方法：" + Request.ServerVariables["REQUEST_METHOD"] + "<BR />" +
                 "服务器的IP地址：" + Request.ServerVariables["LOCAL_ADDR"] + "<BR />";
                #endregion 获取用户的请求的信息

                if (code == null)
                {
                    WriteUcenterCommunicationLogs.WriteErrorLog("异常的访问，访问者信息：" + strRequestInfo);
                    exit("Invalid Request");
                    return;
                }
                WriteUcenterCommunicationLogs.WriteLog("密文：" + code);
                string authcode = ucenter.client_php.uc_authcode(code, "DECODE", ConfigurationManager.AppSettings["UC_KEY"]);
                WriteUcenterCommunicationLogs.WriteLog("明文：" + authcode);

                string[] strArgs = authcode.Split('&');
                if ((strArgs == null) || (strArgs.Length == 0))
                {
                    WriteUcenterCommunicationLogs.WriteErrorLog("异常的访问，明文：" + authcode + "   访问者信息：" + strRequestInfo);
                    exit("Invalid Request!");
                    return;
                }
                Hashtable htArg = new Hashtable();//参数的hashtable

                #region 将参数信息放入hashtable
                foreach (string arg in strArgs)
                {
                    string[] t = arg.Split('=');
                    if (t[0] != null)
                    {
                        htArg.Add(t[0], t[1] == null ? string.Empty : t[1]);
                    }
                }
                #endregion

                #region 将发送过来的参数的值添加到参数的hashtable中（已停止使用）
                ////原方法中此处存在错误，因为参数为加密传递，所以此处无法获得传递的参数的值
                //foreach (string key in Request.QueryString.AllKeys)
                //{
                //    string _ParmatersValue = "";
                //    _ParmatersValue = Request[key];
                //        //Request.QueryString[key];

                //    if (!htArg.Contains(key))
                //        htArg.Add(key, _ParmatersValue);
                //    if (Session["msg"] == null)
                //    {
                //        Session["msg"] = "";
                //    }
                //        Session["msg"] += "  Key:" + key + "   value:" + _ParmatersValue + " ;  ";
                //}

                #endregion

                if (ucenter.client_php.time() - long.Parse((string)htArg["time"]) > 3600)
                {//验证超时
                    exit("Authracation has expiried(Now:" + ucenter.client_php.time() + ",time:" + (string)htArg["time"]);
                    return;
                }
                if (htArg.Count == 0)
                {//错误的请求
                    WriteUcenterCommunicationLogs.WriteErrorLog("异常的访问，明文：" + authcode + "   访问者信息：" + strRequestInfo);
                    exit("Invalid Request");
                    return;
                }

                string action = (string)htArg["action"];
                long timestamp = DateTime.Now.Ticks;

                #region 用于和Ucenter测试通信 这个返回代表着Ucenter中可以显示通信成功
                if (action.Equals("test"))
                {
                    exit(API_RETURN_SUCCEED);
                    return;
                }
                #endregion

                #region synlogin 同步登陆
                string struid = "0";//传递过来的uid
                int uid = 0;//传递过来的uid的整数形式
                if (action.ToLower() == "synlogin")
                {        //明文：action=synlogin&username=admin&uid=1&password=a5f894909abc9152ff48cb71c7468935&time=1280032656       
                    if (htArg.Contains("uid"))
                    {
                        //确实存在uid参数

                        struid = htArg["uid"].ToString();
         
                        //CP=\"CURa ADMa DEVa PSAo PSDo OUR BUS UNI PUR INT DEM STA PRE COM NAV OTC NOI DSP COR\"
                        //string p3pValue="CP=\"CURa ADMa DEVa PSAo PSDo OUR BUS UNI PUR INT DEM STA PRE COM NAV OTC NOI DSP COR\"";
                        //Response.Headers.Add("P3P", p3pValue);

                        WriteUcenterCommunicationLogs.WriteLog("异步登录，uid为：" + struid + " username:" + htArg["username"].ToString() + " pwd:" + htArg["password"].ToString());
                        if (!int.TryParse(struid, out uid))
                        {
                            WriteUcenterCommunicationLogs.WriteErrorLog("错误的uid，处理Ucenter发送过来的同步登陆请求失败，uid为：" + struid);
                        }
                        else
                        {
                            HappyFarm.Model.Member nowmember = new HappyFarm.Model.Member();
                            HappyFarm.BLL.MemberBLL memberBLL = new HappyFarm.BLL.MemberBLL();
                            nowmember = memberBLL.GetModel(uid);
                         
                            if (nowmember != null)
                            {
                                HttpContext.Current.Session["Member"] = nowmember;
                            }
                            else
                            {                              
                                throw new Exception("接收到来自Ucenter的同步登录通知，但未找到该用户！uid="+struid);
                            }
                           
                        }
                        exit(API_RETURN_SUCCEED);
                    }
                }
                #endregion

                #region  同步登出
                if (action.ToLower() == "synlogout")
                {
                    HttpContext.Current.Session.Clear();                   
                    exit(API_RETURN_SUCCEED);
                }
                #endregion

                #region 修改密码
                if (action.ToLower() == "updatepw")
                {
                    //修改密码
                    string username = "";
                    username = htArg["username"].ToString();
                    string pwd = "";
                    pwd = htArg["password"].ToString().Trim();
                    HappyFarm.Model.Member nowmember = new HappyFarm.Model.Member();
                    HappyFarm.BLL.MemberBLL memberBLL = new HappyFarm.BLL.MemberBLL();
                    List<HappyFarm.Model.Member> memberList = new List<HappyFarm.Model.Member>();
                    memberList = memberBLL.GetModelList(" username='" + username + "'");
                    if (memberList.Count == 0)
                    {
                        //不存在用户
                        WriteUcenterCommunicationLogs.WriteErrorLog("同步修改密码错误，不存在用户username为：" + username);
                    }
                    else if (memberList.Count == 1)
                    {
                        try
                        {
                            nowmember = memberList[0];
                            nowmember.PWD = pwd;
                            if ((pwd != null) && (pwd != string.Empty))
                            {//如果密码不为空才修改
                                memberBLL.Update(nowmember);
                                WriteUcenterCommunicationLogs.WriteLog("同步修改密码，用户：" + username+" 密码："+pwd);
                            }
                            else
                            {
                                //密码为空
                                WriteUcenterCommunicationLogs.WriteErrorLog("同步修改密码错误，用户：" + username+"的密码为空。");
                            }

                        }
                        catch (Exception ex)
                        {
                            WriteUcenterCommunicationLogs.WriteErrorLog("同步修改密码错误，用户username为：" + username + "  错误详细信息" + ex.ToString());
                        }
                    }
                    else
                    {
                        WriteUcenterCommunicationLogs.WriteErrorLog("同步修改密码错误，存在多个同名用户，用户username为：" + username);
                    }

                    exit(API_RETURN_SUCCEED);
                    // nowmember = memberBLL.GetModel(uid);
                }
                #endregion
            }
            catch (System.Threading.ThreadAbortException ThAE)
            {
                //对 End、Redirect 和 Transfer 方法的调用在当前响应提前结束时会引发一个 ThreadAbortException 异常。
            }
            catch (Exception ex)
            {
                //exit(API_RETURN_SUCCEED);
                if (ex.GetType() != typeof(System.Threading.ThreadAbortException))
                {
                    WriteUcenterCommunicationLogs.WriteErrorLog(ex.ToString());
                   // throw ex;
                }
            }
        }

        /// <summary>
        /// 将结果回写
        /// </summary>
        /// <param name="msg">要回写的信息</param>
        private void exit(string msg)
        {
            try
            {
                Response.Write(msg);
                Response.End();
            }
            catch (System.Threading.ThreadAbortException ThAE)
            {
                //对 End、Redirect 和 Transfer 方法的调用在当前响应提前结束时会引发一个 ThreadAbortException 异常。
                Server.ClearError();
                
            }
        }
    }
}
